import sys

import numpy as np
import scipy.sparse as sp
from scipy.sparse.linalg import spsolve
import matplotlib.pyplot as plt

import mesh


class SingularMatrixError(Exception):

    def __init__(self, message):
        self.message = message

def compute_kbar(mesh, K, moyenne):

    Kbar = np.zeros_like(mesh.sommets)
    if moyenne == 'constante':
        Kbar = K * np.ones_like(mesh.sommets)
        Kbar[0] = K
        Kbar[-1] = K
    elif moyenne == 'arithmetique':
        Kbar[1:-1] = # à faire
        Kbar[0] = # à faire
        Kbar[-1] = # à faire
    elif moyenne == 'harmonique':
        Kbar[1:-1] = # à faire
        Kbar[0] = # à faire
        Kbar[-1] = # à faire
    return Kbar
    
def getmatrhs1D(mesh, K, bclist, rhs, moyenne='harmonique'):
    Kbar = compute_kbar(mesh, K, moyenne)
    tx = # à faire 
    tx[0] = # ?
    tx[-1] = # ?
    n = len(mesh.centres)
    DiagVecs = # à faire
    A = sp.spdiags(# à compléter).tocsr()

    if callable(rhs):
        b = # à faire 
    else:
        b= rhs.copy() # !! deep copy 

# Boundary conditions
    if bclist[0]['type'] == 'Dirichlet':
        A[0,0] += # à faire
        b[0] += # à faire
    elif bclist[0]['type'] == 'Neumann':
        b[0] += # à faire
        
    if bclist[-1]['type'] == 'Dirichlet':
        A[-1,-1] += # à faire
        b[-1] += # à faire
    elif bclist[-1]['type'] == 'Neumann':
        b[-1] += #à faire


    return A, b


def solve(mesh, K, bclist, rhs, moyenne= 'harmonique'):
    A, b = getmatrhs1D()# à faire
    if bclist[0]['type'] == 'Neumann' and bclist[-1]['type'] == 'Neumann':
        raise SingularMatrixError('Singular matrix')
    u = #à faire 
    return u

def compute_flux(mesh, K, u, moyenne):
    Kbar = compute_kbar(mesh, K, moyenne)
    tx = #à faire 
    tx[0] = # à faire
    tx[-1] = # à faire
    flux = # à faire 
    return flux

def test():
    
    L=1
    N=20
    umesh=mesh.make_uniform_mesh(L,N)
    K=3
    bcleftD = {'type':'Dirichlet', 'value':1.}
    bcleftN = {'type':'Neumann', 'value':-6.}
    bcrightD = {'type':'Dirichlet', 'value':2.}
    bcrightN = {'type':'Neumann', 'value':0.}
    bclist = [bcleftD, bcrightD]
    
    rhsfun = lambda x: 6 * np.ones_like(x)
    solex = lambda x: x * (1 - x) + x + 1
    
    u = solve(umesh, K, bclist, rhsfun, 'constante')
    
    x = umesh.centres
    uex = solex(x)
    erreur = mesh.normeL2(umesh, u-uex) / mesh.normeL2(umesh, uex)
    print("erreur= ", erreur)

    
if __name__ == '__main__':
    test()
